--
-- lust
--
-- Copyright (c) 2014, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

--- Small wrapper around hardon collider that passes collisions on to a
--  CollisionDispatcher.
local HC = require('lust.HardonCollider')

--- Create new CollisionManager
--  @param dispatcher (optional) The dispatcher to pass collisions to
--                    an empty default dispatcher is created if none
--                    is passed
--  @return The new CollisionManager
function CollisionManager(dispatcher)
  local collider = HC(50)

  collider.dispatcher = dispatcher or lust.CollisionDispatcher()

  function collider:collision_start(dt, shape_a, shape_b, mtv_x, mtv_y)
    self.dispatcher:_start_collision(shape_a, shape_b)
  end

  function collider:collision_stop(dt, shape_a, shape_b)
    self.dispatcher:_stop_collision(shape_a, shape_b)
  end

  collider:setCallbacks(function(...) collider:collision_start(...) end,
                function(...) collider:collision_stop(...) end)

  return collider
end

return CollisionManager
