--
-- lust
--
-- Copyright (c) 2014, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local Core = Object:extend()

function Core:new()
  if not G.headless then
    self.images = lust.ImageCache()
    self.quads = lust.QuadCache()
    self.effects = lust.EffectComposer(function() self.states:draw() end)
  end
  self.states = lust.StateManager(self)
  self.input = lust.InputManager()
  self.input:prepare()

end


function Core:update(dt)
  self.states:update(dt)
end


function Core:draw()
  self.effects:draw()
end


return Core
