--
-- lust
--
-- Copyright (c) 2014, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local Flasher = Object:extend()

function Flasher:new()
  self.flashAlpha = 0
  self.tween = flux.group()
  self.flashColor = {}
end


function Flasher:flashScreen(r, g, b, t, onflashed, alpha, t2, oncomplete, mode)
  self.flashColor[1] = r
  self.flashColor[2] = g
  self.flashColor[3] = b
  self.mode = mode
  self.flashAlpha = 0
  self.tween:to(self, t, {flashAlpha = alpha or 255})
    :oncomplete(function()
      if onflashed then
        onflashed()
      end
      self.tween:to(self, t2 or t, {flashAlpha = 0})
        :oncomplete(oncomplete or function() end)
    end)
end


function Flasher:update(dt)
  self.tween:update(dt)
end


function Flasher:draw()
  if self.flashAlpha == 0 then
    return
  end

  if self.mode then
    love.graphics.setBlendMode(self.mode)
  end
  local width, height = love.graphics.getCanvas():getDimensions()
  love.graphics.origin()
  love.graphics.setColor(self.flashColor[1], self.flashColor[2], self.flashColor[3], self.flashAlpha)
  love.graphics.rectangle('fill', 0, 0, width, height)
  love.graphics.setColor(255,255,255,255)

end


return Flasher
