--
-- lust
--
-- Copyright (c) 2014, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

--- Bundles all info that is needed for any type of game
local Gamestate = Object:extend()

--- Create a new Gamestate. Call Gamestate() to call the constructor and obtain
--  the new instance.
--  It creates a subsystem manager, entity manager and a collision manager
--  @param collision_dispatcher The collision dispatcher to be used
function Gamestate:new(collision_dispatcher)
  self.subsystems = lust.SubsystemManager()
  self.entities = self.subsystems:create_subsystem(lust.EntityManager, self)
  self.collider = self.subsystems:create_subsystem(lust.CollisionManager, collision_dispatcher)
end

--- Update subsystems.
--  @param dt Delta time since last update
function Gamestate:update(dt)
  self.subsystems:update(dt)
end

return Gamestate
