--
-- lust
--
-- Copyright (c) 2014, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local KeyConfig = Object:extend()


function KeyConfig:new(...)
  self.actions = {...}
  self:updateKeyMap()
end


function KeyConfig:updateKeyMap()
  self.keymap = {}
  for i,m in ipairs(self.actions) do
    if m[3] ~= nil then
      self.keymap[m[3]] = m[1]
    end
  end
end


function KeyConfig:unmap(key)
  for i, m in ipairs(self.actions) do
    if m[3] == key then
      m[3] = ''
    end
  end

  self:updateKeyMap()
end


function KeyConfig:mapActionToKey(action)
  for i, a in ipairs(self.actions) do
    if a[1] == action then
      return a[3]
    end
  end
end


function KeyConfig:remap(key, action)
  for i, a in ipairs(self.actions) do
    if a[1] == action then
      a[3] = key
      break
    end
  end
  self:updateKeyMap()
end


function KeyConfig:getActions()
  return self.actions
end


function KeyConfig:mapKeyToAction(key)
  return self.keymap[key]
end


return KeyConfig
