--
-- lust
--
-- Copyright (c) 2014, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

--- Base class for post effect renderers, used by EffectComposer
local PostEffect = Object:extend()

--- Create a new post effect. Call PostEffect(...) to call the constructor
--  and obtain the new instance
--  @param shader The shader to be used by the post effect. For very basic
--                effects that need no special draw code, just using the
--                base class and passing a shader in should suffice.
function PostEffect:new(shader)
  self.shader = shader
  self.enabled = true
end

--- Draw the input canvas applying the shader.
function PostEffect:draw(canvas)
  love.graphics.setShader(self.shader)
  love.graphics.draw(canvas, 0,0,0,1,1)
end

return PostEffect
