--
-- lust
--
-- Copyright (c) 2014, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local PostEffect = require 'lust.post_effect'

local ScaleEffect = PostEffect:extend()

function ScaleEffect:new(scale)
  ScaleEffect.super.new(self)
  self.scale = scale
end


function ScaleEffect:draw(canvas)
  local oldmin, oldmag = canvas:getFilter()
  canvas:setFilter('nearest', 'nearest')
  love.graphics.draw(canvas, 0, 0, 0, self.scale, self.scale)
  canvas:setFilter(oldmin, oldmag)
end


return ScaleEffect
