--
-- lust
--
-- Copyright (c) 2014, rnlf
--
-- This library is free software; you can redistribute it and/or modify it
-- under the terms of the MIT license. See LICENSE for details.
--

local TextInput = Object:extend()

function TextInput:new(updatefunc, donefunc, value)
  self.updatefunc = updatefunc
  self.donefunc = donefunc
  self.value = value or ''
end


function TextInput:dispatch_release(key)
end


function TextInput:dispatch_press(key)
  if key == 'backspace' then
    if #self.value == 0 then
      return
    else
      self.value = string.sub(self.value, 1, #self.value - 1)
      self.updatefunc(self.value)
    end
  elseif key == 'return' or key == 'kpenter' then
    self.donefunc(self.value)
  end
end


function TextInput:text_input(char)
  self.value = self.value .. char
  self.updatefunc(self.value)
end


function TextInput:prepare()
  love.keyboard.setKeyRepeat(true)
  love.keyboard.setTextInput(true)
end




return TextInput
